xref: /freebsd/tests/sys/acl/01.sh (revision 1d386b48)
1#!/bin/sh
2#
3# Copyright (c) 2008, 2009 Edward Tomasz Napierała <trasz@FreeBSD.org>
4#
5# Redistribution and use in source and binary forms, with or without
6# modification, are permitted provided that the following conditions
7# are met:
8# 1. Redistributions of source code must retain the above copyright
9#    notice, this list of conditions and the following disclaimer.
10# 2. Redistributions in binary form must reproduce the above copyright
11#    notice, this list of conditions and the following disclaimer in the
12#    documentation and/or other materials provided with the distribution.
13#
14# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
15# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
16# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
17# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
18# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
19# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
20# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
21# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
22# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
23# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
24# SUCH DAMAGE.
25#
26# $FreeBSD$
27#
28
29# This is a wrapper script to run tools-nfs4.test on ZFS filesystem.
30#
31# WARNING: It uses hardcoded ZFS pool name "acltools"
32#
33# If any of the tests fails, here is how to debug it: go to
34# the directory with problematic filesystem mounted on it,
35# and do /path/to/test run /path/to/test tools-nfs4.test, e.g.
36#
37# /usr/src/tools/regression/acltools/run /usr/src/tools/regression/acltools/tools-nfs4.test
38#
39# Output should be obvious.
40
41if ! sysctl vfs.zfs.version.spa >/dev/null 2>&1; then
42	echo "1..0 # SKIP system doesn't have ZFS loaded"
43	exit 0
44fi
45if [ $(id -u) -ne 0 ]; then
46	echo "1..0 # SKIP you must be root"
47	exit 0
48fi
49
50echo "1..4"
51
52TESTDIR=$(dirname $(realpath $0))
53
54# Set up the test filesystem.
55MD=`mdconfig -at swap -s 64m`
56MNT=`mktemp -dt acltools`
57trap "cd /; zpool destroy -f acltools; rmdir $MNT; mdconfig -d -u $MD" EXIT
58zpool create -m $MNT acltools /dev/$MD
59if [ $? -ne 0 ]; then
60	echo "not ok 1 - 'zpool create' failed."
61	echo 'Bail out!'
62	exit 1
63fi
64
65echo "ok 1"
66
67cd $MNT
68
69# First, check whether we can crash the kernel by creating too many
70# entries.  For some reason this won't work in the test file.
71touch xxx
72setfacl -x2 xxx
73while :; do setfacl -a0 u:42:rwx:allow xxx 2> /dev/null; if [ $? -ne 0 ]; then break; fi; done
74chmod 600 xxx
75rm xxx
76echo "ok 2"
77
78perl $TESTDIR/run $TESTDIR/tools-nfs4-psarc.test >&2
79
80if [ $? -eq 0 ]; then
81	echo "ok 3"
82else
83	echo "not ok 3 # TODO: fails due to ACL changes in ZFS; bug 212323"
84fi
85
86echo "ok 4"
87